<?php

if (!$TEMPLATE_ID) {
 halt(7, "template_def: no template_id for defining tags: TEMPLATE_ID($TEMPLATE_ID)");
}

$p = perm($USER_ID, $T_FOLDER, $FOLDER_ID, 17);

if ($p) {
 $lock = lock($TEMPLATE_ID, "template");
}

if (!$p) {
 $lock = false;
}

if ($lock) {
 $NODERELATED[$DO][] = $TEMPLATE_SAVE;

 if ($FEATURE["template_release"]) {
 $NODERELATED[$DO][] = $TEMPLATE_RELEASE;
 }
}


if ($id) {
 $TEMPLATETAG_ID = $id;
}

mysession_var_reg("TEMPLATETAG_ID");
$lst = new item_list;
$ires = item_order("name", "ASC", array (
 "templatetag.name" => "name",
 "dicuser.value" => "construct"
));

$sql = "SELECT templatetag.id, templatetag.name, templatetag.pub, templatetag.mandatory, dicuser.value AS construct, construct.icon, construct.id as construct_id " . $ires["select"] . " FROM templatetag
LEFT JOIN construct ON (templatetag.construct_id = construct.id)
LEFT JOIN dicuser ON (construct.name_id = dicuser.output_id AND dicuser.language_id = " . sqlf_tl_num($LANGUAGE) . ")
WHERE template_id = " . sqlf_tl_num($TEMPLATE_ID) . $ires["orderby"];
$rs = query($sql); 
$o_tags = $rs["arr"];

if ($rs["num"] > 0) {
 $where = get_visible_constructs("construct.id", getMasterNode($NODE_ID));
 $sql = "SELECT construct.id, dicuser.value AS name, LOWER(dicuser.value) AS l_name FROM construct
	  LEFT JOIN dicuser ON (construct.name_id = dicuser.output_id AND dicuser.language_id = " . sqlf_tl_num($LANGUAGE) . ")
	  WHERE $where
	  ORDER BY l_name";
 $rs = query($sql); 
 if (!$cs = reduce_array($rs["arr"], "id", "name")) {
 $cs = Array ();
 }

 
 $_o_tags = Array ();
 while (list ($key, $val) = each($o_tags)) {
 if (!$META_TAGS[$val["name"]]) {
 
 $_o_tags[$key] = $val;

 
 $_var_c = "c_" . $val["id"];
 $tmp = $HI["sel"];
 $tmp["list"] = $cs;
 $tmp["var"] = $_var_c;
 $hi[] = $tmp;
 $$_var_c = $val["construct_id"];

 
 $_var_pub = "pub_" . $val["id"];
 $tmp = $HI["checkbox"];
 $tmp["var"] = $_var_pub;
 $tmp["value"] = 1;
 $hi[] = $tmp;
 $$_var_pub = $val["pub"];
 
 
 $_var_mandatory = "mandatory_" . $val["id"];
 $tmp = $HI["checkbox"];
 $tmp["var"] = $_var_mandatory;
 $tmp["value"] = 1;
 $hi[] = $tmp;
 $$_var_mandatory = $val["mandatory"];
 }
 }
 $o_tags = $_o_tags;
 reset($o_tags);
}


if ($f_tpl_ass || $tpl_ass) {
 $hi[] = $HI["prev"];
 $hi[] = $HI["cancel"];
 $tmp = $HI["next"];
 $tmp["label"] = i18n("done");
 $hi[] = $tmp;
}
else {
 if (perm($USER_ID, $T_FOLDER, $FOLDER_ID, 17)) {
 $hi[] = $HI["reset"];
 $hi[] = $HI["apply"];
 }
}


$tmp = $HI["hidden"];
$tmp["var"] = "tpl_ass";
$hi[] = $tmp;
$f = new htmlform($hi, "template_def");

if ($faction == "cancel") {
 if ($tpl_ass) {
 
 $TEMPLATE_ID = 0;
 $REDO = 13011;
 }
 else {
 $REDO = 12002;
 }
 $f->clear();
}

if ($faction == "prev") {
 unset ($hi);
 unset ($faction);
 $REDO = 12002;
}


if (($faction == "apply" || $faction == "next") && !$f->err()) {
 if ($o_tags) {
 reset($o_tags);

 while (list ($key, $val) = each($o_tags)) {
 $_var_c = "c_" . $val["id"];
 $_var_pub = "pub_" . $val["id"];
 $_var_mandatory = "mandatory_" . $val["id"];

 if (!$$_var_pub) {
 $$_var_pub = 0;
 }

 tag_tpldef($val["id"], $$_var_c, $$_var_pub, $$_var_mandatory);
 }

 if ($FEATURE["javaparser"]) {
 global $T_TEMPLATE;
 $javaParser = & CodeParser :: getJavaParser();
 $javaParser->clearCache($T_TEMPLATE, $TEMPLATE_ID);
 }
 }
}

if ($faction == "next") {
 $f->clear();
 unset ($hi);
 $REDO = 12006;
}


if (is_array($o_tags)) {
 reset($o_tags);
 while (list($key, $val) = each($o_tags)) {
 $val["icon"] = tag_icon($val["icon"]);

 
 
 if ($lock) {
 $val["pub"] = $f->e("pub_" . $val["id"]);
 $val["mandatory"] = $f->e("mandatory_" . $val["id"]);
 $val["construct"] = $f->e("c_" . $val["id"]);
 }
 else {
 $val["pub"] = ( $val["pub"] == 1 ? i18n('yes') : i18n('no') );
 $val["mandatory"] = ( $val["mandatory"] == 1 ? i18n('yes') : i18n('no') );
 }

 
 $data[$val["id"]]["icon"] = $val["icon"];
 $data[$val["id"]]["name"] = $val["name"];

 if (!$META_TAGS[$val["name"]]) {
 $_o_tags[$key] = $val;
 }
 }
 $o_tags = $_o_tags;
}

if (!$tpl_ass) {
 load_menu(12007, $T_TEMPLATE, $TEMPLATE_ID, i18n('define_tags'));
}
