<?

include("$NODEPATH/modules/system/include/sortorderhelper.inc.php");

GUIFactory::setMainGUI( "main" );

mysession_var_reg("CONSTRUCT_CATEGORY_EDIT_ID");

if( $argcategory ) $CONSTRUCT_CATEGORY_EDIT_ID = $argcategory;


class NameFormatter extends ResultsetFormatter {
 function NameFormatter() {
 }
 function format( $row ) {
 global $CONSTRUCT_CATEGORY_EDIT_ID;
 $val = $row['name'];
 if( $row['id'] == $CONSTRUCT_CATEGORY_EDIT_ID )
 return "<b>$val</b>";
 return $val;
 }
}
class IconFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $ICO_CONSTRUCT;

 return img( $ICO_CONSTRUCT );
 }
}

$listform = new HtmlForm3("objprop_category_list");

node_class("listcomponent");
node_class("textcomponent");
node_class("itemlistcomponent");

unset($CONSTRUCT_ID);
load_menu( 10003, T_CONSTRUCT_CATEGORY );

doMoveCommand('construct_category', T_CONSTRUCT_CATEGORY);

function cancelAction( &$form ) {
 global $CONSTRUCT_CATEGORY_EDIT_ID;
 $CONSTRUCT_CATEGORY_EDIT_ID = false;
}
function deleteCategory( $id ) {
 $sql = "SELECT COUNT(*) AS construct_count FROM construct WHERE category_id = '".sqlf_escaped($id)."'";
 $rs = query( $sql );
 if( $rs['num'] > 0 && $c = $rs['arr'][0]['construct_count'] ) {
 global $JS;
 $JS .= 'alert("'.i18n('Category is still used for {0} Constructs.',NULL,array( $rs['arr'][0]['construct_count'] ) ) . '");';
 return;
 }
 $sql = "DELETE FROM construct_category WHERE id = '".sqlf_escaped($id)."'";
 query( $sql );

 
 $sql = "DELETE FROM perm WHERE o_type = ".sql_num(T_CONSTRUCT_CATEGORY)." AND o_id = ".sql_num($id);
 query($sql);
}
function saveAction( &$form ) {
 global $CONSTRUCT_CATEGORY_EDIT_ID, $maxsortorder;

 $fcatname = $form->resolveComponent( 'main.categoryname' );
 $categoryname = $fcatname->getText();
 if( $CONSTRUCT_CATEGORY_EDIT_ID == 'new' ) {
 $sql = "SELECT MAX(sortorder) AS max FROM construct_category";
 $rs = query( $sql );
 $sortorder = $rs['arr'][0]['max'] + 1;
 $maxsortorder = $sortorder;
 $name_id = word( $categoryname, 6 );
 $sql = "INSERT INTO construct_category (name_id) values ('".sqlf_escaped($name_id)."')";
 $rs = query( $sql );
 $CONSTRUCT_CATEGORY_EDIT_ID = $rs['iid'];

 
 $sql = "INSERT INTO perm (usergroup_id, o_type, o_id, perm) select id, ".sql_num(T_CONSTRUCT_CATEGORY).", ".sql_num($rs['iid']).", '10000000000000000000000000000000' FROM usergroup";
 query($sql);
 } else {
 $sql = "SELECT name_id FROM construct_category WHERE id = '".sqlf_escaped($CONSTRUCT_CATEGORY_EDIT_ID)."'";
 $rs = query( $sql );
 $old_name_id = $rs['arr'][0]['name_id'];
 if( !$old_name_id ) {
 $name_id = word( $categoryname, 6 );
 $sql = "UPDATE construct_category SET name_id = '".sqlf_escaped($name_id)."' WHERE id = '" . sqlf_escaped($CONSTRUCT_CATEGORY_EDIT_ID) . "'";
 query( $sql );
 } else {
 word( $categoryname, 6, $old_name_id );
 }
 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_CONSTRUCT_CATEGORY, $CONSTRUCT_CATEGORY_EDIT_ID);
 }
 cancelAction( $form );
}


$sql = "SELECT min(sortorder) AS min, max(sortorder) AS max from construct_category";
$rs = query( $sql );
$minsortorder = $rs['arr'][0]['min'];
$maxsortorder = $rs['arr'][0]['max'];

if ($listform->isNew()) {

 $main = new ListComponent();



 $select = "construct_category.id, name_id, dicuser.value AS name, sortorder";
 $from = "construct_category LEFT JOIN dicuser ON construct_category.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE);

 $ds = new SQLDatasource( "objprop_category_listds", $select, $from, '', '', 'sortorder' );
 $ds->setDBHandle( $DB );
 $ds->setSearchable( false );

 $ds->addColumn( 'icon', '', false, false );
 $ds->addFormatter( 'icon', new IconFormatter() );

 $ds->addColumn( "lnkname", i18n( "Category Name" ), true, false );

 $ds->makeLink( 'lnkname', 'name', "do=$DO", 'list', 'argcategory', 'id' );

 $ds->addColumn( 'sortorder', i18n( "Order"), false, false );

 $ds->addFormatter( 'sortorder', new SortOrderFormatter() );

 $ds->addFormatter( 'name', new NameFormatter() );

 $ds->addAction( new CommandAction( $ICO_DELETE, 'del', i18n( 'delete'), 'deleteCategory' ) );



 $list = new ItemList3("construct_category_list", $ds );
 $list->setMaxListItems(50);
 $list->setShowInfo( true );

 $main->setComponent('somelist', new ItemListComponent( '', $list ) );

 $listform->setHeader( i18n( 'Construct Categories' ), $ICO_CONSTRUCT );
 $listform->addComponent( 'main', $main );
} else {
 $myitemlistcomp = & $listform->resolveComponent( 'main.somelist' );
 $itemlist3 = & $myitemlistcomp->getList();
 $dsn = & $itemlist3->getDatasource();
 $dsn->setDBHandle( $DB );
}



if( $CONSTRUCT_CATEGORY_EDIT_ID ) {
 $edit_form = new HtmlForm3("construct_category_list_edit");

 if( $edit_form->isNew() ) {
 $editmain = new ListComponent();

 if( $OBJPROP_CATEGORY_EDIT_ID != 'new' ) {
 $sql = "SELECT name_id,dicuser.value AS name FROM construct_category LEFT JOIN dicuser ON construct_category.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." WHERE construct_category.id = '".sqlf_escaped($CONSTRUCT_CATEGORY_EDIT_ID)."'";
 $rs = query( $sql );
 $categoryname = $rs["arr"][0]["name"];
 }
 
 $name = new TextComponent( 'Name', true, $categoryname );
 $name->setOptional( false );
 $name->setRegex( '.+', i18n( "Please Enter a Name" ) );

 $editmain->setComponent( 'categoryname', $name );

 $edit_form->addComponent( 'main', $editmain );

 $edit_form->addButton( 'save', new Button( i18n( "OK" ) ), new SimpleFormAction( "saveAction" ) );
 $edit_form->addButton( 'cancel', new Button( i18n( "Cancel" ), false ), new SimpleFormAction( "cancelAction" ) );

 $edit_form->setHeader( i18n('Edit Category'), $ICO_OBJPROP );
 }
}


?>
