<?



$mainGui =& GUIFactory::setMainGUI("main");
$mainGui->enterHistory();

node_include('is_editable_construct');

unset($CON_ASS);
unset($CONSTRUCT_ID);
unset($PID);

$lst = new item_list;
$lst->enablePaging = true;


if ($item_cmd == "del" && $item_id) construct_del($item_id);
if ($item_cmd == "copy" && $item_id) construct_copy($item_id);
if (($item_cmd == "link" || $item_cmd == "unlink") && $item_id) {
 unset($faction);
 unset($hi);
 $REDO = 16005;
 $SOURCE = $item_id;
 $cmd = "construct".$item_cmd;
 $cmd2 = "new";
}
if ($item_cmd == "assign_category" && $item_id) {
 unset($faction);
 unset($hi);
 $REDO = 10017;
 $SOURCE = $item_id;
 return;
}

if ($treemenu) $TREEMENU = $treemenu;
load_menu(10003,$T_CONSTRUCTS,$TREEMENU, i18n("View Constructs"));


$fc = new fetchCurl();
$url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/construct/list?sid=$SESSION_TOKEN";


$ires = item_order("category","asc",array("category"=>"category", "construct.keyword" => "keyword","dicn.value"=>"name","dicd.value"=>"description",));
$url .= "&sortby={$ires['field']}&sortorder=".strtolower($ires['way']);


if ( $dosearch ) {
 $url .= "&search=".urlencode($search);

 
 if ($category) {
 $url .= "&category=".urlencode($category);
 }

 
 if ($node) {
 $url .= "&nodeId=".urlencode($node);
 }
}

$fc->setUrl($url);
$json = $fc->doRequest();


if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
} else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
}

$o_constructs = json_decode($json,true);
$o_constructs = $o_constructs["constructs"];


node_include("keymapper");
$km = new KeyMapper(array(
 "editor.firstName" => "e_firstname",
 "editor.lastName" => "e_lastname",
 "creator.firstName" => "c_firstname",
 "creator.lastName" => "c_lastname"
));
$o_constructs = $km->remap($o_constructs);

$i = 0;
if ($o_constructs) 
while (list($key,$val) = each($o_constructs)) {
 $editable = is_editable_construct($val["id"]);
 if ($onlyeditable && !$editable) {
 unset($o_constructs[$key]);
 continue;
 }
 if ($editable) {
 $val["icon"] = img(tag_icon($val["icon"]));
 } else {
 
 $val["icon"] = '<img src="' . tag_icon($val["icon"]) . '" style="opacity:0.4;filter:alpha(opacity=40)" />';
 }
 $val["cdate"] = db2date($val["cdate"]);
 $val["edate"] = db2date($val["edate"]);
 if( $val['category'] === NULL ) {
 $val['category'] = i18n( 'Other' );
 }
 $o_constructs[$key] = $val;
}
ass_search($DO,"",0);

?>
